/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.client.internal.DescriptionClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() {

/*
 * Aliases
 */
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;

/*
 * Constants
 */
var _SERVICE_URI = "com.ibm.team.dashboard.viewlets.service.internal.description.IDescriptionService";

/*
 * Retrieves the descriptions of the specified process area.
 */
com.ibm.team.dashboard.viewlets.web.client.internal.DescriptionClient.getDescriptionsForProcessArea =
/* String[] */ function(/* number */ scope, /* string */ scopeItemId, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
	var req = new ServiceRequest(_SERVICE_URI, "getDescriptionsForProcessArea", {scope: scope, scopeItemId: scopeItemId});
	if (tracker) {
		tracker.register(req, srh);
	}
	TeamServerClient.invokeService(req, srh);
}

})();