/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.client.internal.MemberInfoClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

(function() {

/*
 * Aliases
 */
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

/*
 * Constants
 */
var _SERVICE_URI = "com.ibm.team.dashboard.viewlets.service.internal.members.IMemberInfoService";

com.ibm.team.dashboard.viewlets.web.client.internal.MemberInfoClient.getMemberInfo =
/* MemberInfoDTO[] */ function(/* string[] */ itemIds, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
	var req = new ServiceRequest(_SERVICE_URI, "getMemberInfo", {itemIds: itemIds});
	if (tracker) {
		tracker.register(req, srh);
	}
	TeamServerClient.invokeService(req, srh);
}

/* Cache all the role descriptions fo reach process area to avoid repeated server calls */
var _processAreas = new Array();

com.ibm.team.dashboard.viewlets.web.client.internal.MemberInfoClient.getRoleDescription =
/* MemberInfoDTO[] */ function(/* string */ roleId, /* int */ processAreaScope, /* string */ processAreaItemId, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
	if (_processAreas[processAreaItemId] && _processAreas[processAreaItemId][roleId])
		srh.doCallback(_processAreas[processAreaItemId][roleId]);
	var serviceObj = {
		success: function(/* string */ description) {
			if (description) {
				if (!_processAreas[processAreaItemId])
					_processAreas[processAreaItemId] = new Array();
				_processAreas[processAreaItemId][roleId] = description;
				srh.doCallback(description);
			} else
				srh.doCallback();
		},
		failure: function(error) {
			srh.doErrorCallback(error);
		}
	};
	var srh2 = new ServiceResponseHandler(serviceObj, "success", "failure");
	var req = new ServiceRequest(_SERVICE_URI, "getRoleDescription", {roleId: roleId, processAreaScope: processAreaScope, processAreaItemId: processAreaItemId});
	if (tracker) {
		tracker.register(req, srh2);
	}
	TeamServerClient.invokeService(req, srh2);
}

})();