/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.process.web.ui.internal.ProjectAreaListApplication"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.internal.Dialog"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.ui.internal._JazzApplication"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var PlatformUI				= net.jazz.ajax.ui.PlatformUI;
var RepositoryClient 		= com.ibm.team.repository.web.client.internal.RepositoryClient;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var InitializationData      = com.ibm.team.repository.web.client.init.InitializationData;
var Dialog                  = net.jazz.ajax.ui.internal.Dialog;

dojo.declare(
	"com.ibm.team.process.web.ui.internal.ProjectAreaListApplication", //$NON-NLS-1$
	com.ibm.team.repository.web.ui.internal._JazzApplication, {
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	init: function() {
		var srh = new ServiceResponseHandler(
			this, "_fetchInitDataSuccess", "_fetchInitDataFailure"); //$NON-NLS-1$ //$NON-NLS-2$
		RepositoryClient.getInitializationData(srh);
	},
	
	_fetchInitDataSuccess: function(initializationData) {
		InitializationData._load(initializationData);
		
		// set the global var for the logged-in contributor
		try {
			dojo.setObject(
				"com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR", //$NON-NLS-1$
				InitializationData.get("com.ibm.team.repository.service.currentContributorInitializer").currentContributor); //$NON-NLS-1$
		} catch (e) {
			document.title = this.messages.ProjectAreaListApplication_1;
			var content = document.createElement("div"); //$NON-NLS-1$
			content.style.padding = "1em"; //$NON-NLS-1$
			var mainContent = document.createElement("div"); //$NON-NLS-1$
			mainContent.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_2));
			var adminContent = document.createElement("div"); //$NON-NLS-1$
			var foo = this.messages.ProjectAreaListApplication_3;
			var adminWebUILink = dojo.string.substitute("<a href=\"${0}\">${1}</a>", [ net.jazz.ajax._contextRoot + "/admin", this.messages.ProjectAreaListApplication_3 ]); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			adminContent.style.paddingTop = "8px"; //$NON-NLS-1$
			adminContent.innerHtml = dojo.string.substitute(this.messages.ProjectAreaListApplication_4, [ adminWebUILink ]);
			content.appendChild(mainContent);
			content.appendChild(adminContent);
			var dialog = new Dialog({primaryTitle: this.messages.ProjectAreaListApplication_5, contentNode: content});
			return;
		}
			
		// store the configuration properties in global vars with corresponding
		// names
		var configProperties = InitializationData.get("com.ibm.team.repository.service.configPropertyInitializer"); //$NON-NLS-1$
		for (var propName in configProperties) {
			var propVal = configProperties[propName];
			dojo.setObject(propName, propVal);
		}
		
		// initialize the UI
		var args = {
			label: this.messages.ProjectAreaListApplication_6,
			showLoginPanel: true
		};
		this._initUI(args);
		PlatformUI.getWorkbench()._setDefaultTitle(this.messages.ProjectAreaListApplication_7);
		ProjectAreaList.superclass.start.call(this);
	},
	
	_fetchInitDataFailure: function(errorObj) {
		if (errorObj.status == 401) {
			var content = document.createElement("div"); //$NON-NLS-1$
			content.style.padding = "1em"; //$NON-NLS-1$
			content.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_8));
			if (dojo.cookie("JazzFormAuth") != null) { //$NON-NLS-1$
				content.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_9));
				var button = document.createElement("button"); //$NON-NLS-1$
				button.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_10));
				var buttonDiv = document.createElement("div"); //$NON-NLS-1$
				buttonDiv.style.textAlign = "center"; //$NON-NLS-1$
				buttonDiv.style.marginTop = "1em"; //$NON-NLS-1$
				buttonDiv.appendChild(button);
				content.appendChild(buttonDiv);
				var dialog = new Dialog({primaryTitle: this.messages.ProjectAreaListApplication_11, contentNode: content});
				dojo.connect(button,"onclick",dialog,function (e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this.close();
					var bindArgs = {
				        url: dojo.baseUrl + "../../auth/logout", //$NON-NLS-1$
				        content: { },
						handle: dojo.hitch(this, function(response, ioArgs){
							window.location.reload();
				        })
				    };
				    dojo.xhrPost(bindArgs);
				});
			}
			else {
				content.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_12));
				var button = document.createElement("button"); //$NON-NLS-1$
				button.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_13));
				var buttonDiv = document.createElement("div"); //$NON-NLS-1$
				buttonDiv.style.textAlign = "center"; //$NON-NLS-1$
				buttonDiv.style.marginTop = "1em"; //$NON-NLS-1$
				buttonDiv.appendChild(button);
				content.appendChild(buttonDiv);
				var dialog = new Dialog({primaryTitle: this.messages.ProjectAreaListApplication_14, contentNode: content});
				dojo.connect(button,"onclick",dialog,function (e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this.close();
					window.location.reload();
				});
			}
		}
		else {
			var content = document.createElement("div"); //$NON-NLS-1$
			content.style.padding = "1em"; //$NON-NLS-1$
			content.appendChild(document.createTextNode(errorObj.message));
			var button = document.createElement("button"); //$NON-NLS-1$
			button.appendChild(document.createTextNode(this.messages.ProjectAreaListApplication_15));
			var buttonDiv = document.createElement("div"); //$NON-NLS-1$
			buttonDiv.style.textAlign = "center"; //$NON-NLS-1$
			buttonDiv.style.marginTop = "1em"; //$NON-NLS-1$
			buttonDiv.appendChild(button);
			content.appendChild(buttonDiv);
			var dialog = new Dialog({primaryTitle: this.messages.ProjectAreaListApplication_16, contentNode: content});
			dojo.connect(button,"onclick",dialog,function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			});
		}
	}
});

var ProjectAreaList = com.ibm.team.process.web.ui.internal.ProjectAreaListApplication;

})();
