/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ManageArchivedProjectAreas"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

dojo.require("com.ibm.team.process.web.client.projectarea"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.ui.internal.admin.ItemList"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

function setText(e, text){
	e.appendChild(document.createTextNode(text));
}

var PROJECT_ACTION_PREFIX = "com.ibm.team.process.editArchivedProjectArea&itemId="; //$NON-NLS-1$

dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ManageArchivedProjectAreas", com.ibm.team.repository.web.ui.internal.admin.ItemList, { //$NON-NLS-1$

	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		setText(this.heading, this.messages.ManageArchivedProjectAreas_1);
		setText(this.description, this.messages.ManageArchivedProjectAreas_2);
		this.tableHeading.parentNode.removeChild(this.tableHeading);
		this.newItemButtonArea.parentNode.removeChild(this.newItemButtonArea);
		this.setHeaderRow([this.messages.ManageArchivedProjectAreas_3, this.messages.ManageArchivedProjectAreas_4]);
		this.headerRow.cells[0].style.width = "30%"; //$NON-NLS-1$
		this.refresh();
	},
	
	refresh: function () {
		this.clearState();
		var tr = document.createElement("tr"); //$NON-NLS-1$
		var td = document.createElement("td"); //$NON-NLS-1$
		td.colSpan = 2;
		td.appendChild(document.createTextNode(this.messages.ManageArchivedProjectAreas_5));
		tr.appendChild(td);
		this.tbody.appendChild(tr);
		var srh = new ServiceResponseHandler(this, "showProjects", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
		ProcessClient.getAllProjectAreas(srh, { onlyArchivedProjects: true });
	},
	
	clearState: function () {
		dojox.data.dom.removeChildren(this.tbody);
		dojox.data.dom.removeChildren(this.messageDiv);
		dojox.data.dom.removeChildren(this.messageBox);
		this.messageBox.className = ""; //$NON-NLS-1$
	},
	
	showProjects: function(data) {
		dojox.data.dom.removeChildren(this.tbody);
		if (data != null) {
			var sortedData = data.sort(function (a,b) {
				return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
			});
			for (var i=0; i < sortedData.length; i++) {
				var actionHref = PROJECT_ACTION_PREFIX + sortedData[i].itemId;
				var span = document.createElement("span"); //$NON-NLS-1$
				span.appendChild(document.createTextNode(sortedData[i].summary));
				if (sortedData[i].description) {
					span.appendChild(document.createElement("br")); //$NON-NLS-1$
					span.appendChild(document.createElement("br")); //$NON-NLS-1$
					span.appendChild(document.createTextNode(sortedData[i].description));
				}
				var row = this.addRow(actionHref, [sortedData[i].name, span]);
				if (i === 0) {
					dojo.toggleClass(row.parentNode,"projectTable",true); //$NON-NLS-1$
				}
			}
		}
		else {
			this.messageDiv.appendChild(document.createTextNode(this.messages.ManageArchivedProjectAreas_6));
		}
	}
});

})();