/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.common.ServiceCallController"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var PlanningUtil		= com.ibm.team.apt.web.client.util;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.common.ServiceCallController", null, { //$NON-NLS-1$

	constructor: function(aptView) {
		this._view = aptView;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	remoteError: function(error) {
		// TODO improve error handling
		console.log(error);
		var errorMessage= error != null && error.message != null ? bind(MSGS.ERROR_REMOTE_DETAILS, [error.message]) : MSGS.ERROR_REMOTE;
		
		alert(errorMessage);
	}, 

	setProgressMessage: function(label) {
		return this._view._showProgressMessage(label);
	},
	
	removeProgressMessage: function(messageId) {
		this._view._hideProgressMessage(messageId);
	},

	__sentinel: null // terminates this class definition
});

})();
