/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemTabContentLayout");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil");
// Section Layout required here for debugging
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TwoColumnLayout");

dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");


(function() {
	
var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;

var ImageClient				= com.ibm.team.workitem.web.client.internal.ImageClient;
var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var WorkItemUtil            = com.ibm.team.workitem.web.client.util;
var EditorUtil            = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var LayoutUtil            = com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var ImagePool				= com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
var isGuest 				= com.ibm.team.repository.web.client.session.isGuest;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemTabContentLayout",
	[dijit._Widget, dijit._Templated],
	{
		templateString: "<div><div dojoAttachPoint='_containerDIV'></div>",
		/*
		 * The sectionMap is used to map the sections to the layout
		 * 
		 */
		sectionMap: {
				defaultSection: {
//						title: "Default",
						column: "single", // single, left or right
					 	renderFunctionName: "_renderColumnSection"
//						highlightBackground: true,
//						className: "SectionStyle",
						},
				links: {
//						title: "Links",
						column: "left", // single, left or right
					 	renderFunctionName: "_renderColumnSection"
//						highlightBackground: true,
//						className: "SectionStyle",
						},
				attachments: {
//						title: "Attachments",
						column: "left", // single, left or right
					 	renderFunctionName: "_renderColumnSection"
//						highlightBackground: true,
//						className: "SectionStyle",
						},
				subscribers: {
//						title: "Subscribers",
						column: "right", // single, left or right
					 	renderFunctionName: "_renderColumnSection"
//						highlightBackground: true,
//						className: "SectionStyle",
						}
			},
		/*
		 * The modifierMap is used to build the modifiers object passed to the widget
		 * It includes formatting and control information not defined in the 
		 * process spec.  Over time, it may make sense to move some of this information
		 * down to the process spec and then remove it from the modifier map.
		 * 
		 * Different modifiers are supported by different widgets.
		 * 
		 * Modifiers are first applied to specific attributes, but can also be
		 * specified for parts/widgets.
		 * 
		 * Currently functions are called in the parentWidget (e.g., this widget)
		 * 
		 * attributeLabel: the label used in the window before the field
		 *
		 * localModifierFunction: the name of a function to call before constructing the 
		 *     widget which allows the values, possible values and modifiers to be changed
		 * 
		 * spanColumns: True if the widget needs to span both columns
		 * 
		 * onCreate: the name of a function to call when the  widget is created
		 * onValueChanged: the name of a function to call when the widget value is changed
		 * 
		 * moreLabel, moreTitle, moreFunctionName: custom modifiers for the ContributorWidget
		 * noValueLabel: Label to show when a label or date has no value
		 * noValueTitle: Title/tooltip to show when a label or date has no value
		 */	
		_modifierMap: {
//				workItemType: {
//					attributeLabel: "Type",
//					onCreate: "_handleWorkItemTypeChange",
//					onValueChanged: "_handleWorkItemTypeChange"
//					}
			},
		postCreate: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			 var _columnLayout= /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.layout.TwoColumnLayout( 
				{},
				this._containerDIV
			);
			this._childWidgets = {};
			this._workItem = this.workItem;
			this._workItem.displayedAttributes = this._workItem.displayedAttributes ? this._workItem.displayedAttributes : {};
			this.pageProps = this.presentationProps;
			if(this.pageProps && this.pageProps.sections) {
				
				for(var i=0;i<this.pageProps.sections.length;i++) {
					LayoutUtil.layoutSection(this, this.pageProps.sections[i], this.sectionMap, _columnLayout, this.parentController, this._childWidgets);
				}				
			}

			for(var widget in this._childWidgets) {
				if(this._childWidgets[widget].setFormElementValues) {
					this._childWidgets[widget].setFormElementValues(this.retainedState);					
				}
			}
		

		},
		// Called when the tab is shown
		showWidget: function() {
			if(this.isShown) return;
			this.isShown = true; // only do this once
			this._notifyChildren("showWidget", null, false);
		}, 
		destroyWidget: function()  {
			this.parentController.pageController.removeAllMouseListeners(this);
			this._notifyChildren("destroyWidget", null);
			this._notifyChildren("destroy", null);
			this.destroy();			
		},
	 /*
	 * Notify each child that an event occured
	 */
		_notifyChildren: function(selector, parm, isSafe) {
			for(var widget in this._childWidgets) {
				if(this._childWidgets[widget][selector]) {
					if (isSafe) {
						try {
							this._childWidgets[widget][selector](parm);
						} 
						catch (e) {
							console.debug("Error attempting child function " + selector + " in " + widget);
						}
					} else {
						this._childWidgets[widget][selector](parm);
					}


				}
			}
		},
		findObjectWithProperty: function(/* property, path */ parms) {
			var object; 
			if (this[parms.property]) {
				object = this;
			} else {
				object = EditorUtil.findObjectWithPropertyInObject({
				object: this._childWidgets,
				path: parms.path,
				property: parms.property
					}, this); 
			}
			return object; 
		},
		/*
		 * Render a section with one column of widgets
		 */
		_renderColumnSection: function(sectionNode, section, sectionLayout) {
			var values = [];
			var possibleValues = [];
			var modifiers = {};
			if(!section || !section.presentations) return;
			for(var i=0;i<section.presentations.length;i++) {
				var widgetNode = document.createElement("DIV");
				sectionNode.appendChild(widgetNode);
				this._addWidget(/* creationSpec */ null, section.presentations[i], widgetNode, values, possibleValues, modifiers, sectionLayout);
			}
		},


	    _addWidget: function(creationSpec, presentation, valueNode,  values, possibleValues, modifiers, sectionLayout) {
//			console.debug(presentation.widget +" "+ presentation.attributeId);

			if(!creationSpec) {
				creationSpec = LayoutUtil.getPresentationWidget(presentation);
			}

			var propertyModifiers = LayoutUtil.getPropertyMap(presentation, this._modifierMap[presentation.attributeId]);
			LayoutUtil.mergeObjects(modifiers, propertyModifiers);
			
			// If the attribute is already displayed, substitute a separator with error message.
	    	var attributeId = propertyModifiers.attributeId ? propertyModifiers.attributeId : presentation.attributeId;
	    	attributeId = attributeId ? attributeId : presentation.widget.replace(/\./g,"_");
			creationSpec.isNotAvailable = false;
			if (attributeId) {
				if (this._workItem.displayedAttributes[attributeId]) {
					creationSpec.widget = com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget;
					creationSpec.isBlockedAttributePresentation = true;
					if(presentation.widget != "com.ibm.team.workitem.web.ui.internal.view.editor.parts.EnumerationAttributePart") {
						creationSpec.isNotAvailable = true;
						console.debug(dojo.string.substitute(this.messages.errorDuplicateAttributePresentation, [attributeId]));
					}
				}
				else {
					this._workItem.displayedAttributes[attributeId] = true;
				}
			}
			
			var widgetClass = creationSpec.widget;
			var self = this;
			if(widgetClass) {
					var creationArgs = {
						parentWidget: this,
						creationSpec: creationSpec,
						workItem: this._workItem,
						parentController: this.parentController,
						attributeId: presentation.attributeId,
						attributeValue: this._workItem.attributes[attributeId],
						values: values,
 						valueNode: valueNode,
						sectionLayout: sectionLayout,
						_modifiers: modifiers,
						_possibleValues: possibleValues
					}
					
					// If the widget is missing and we are not debugging, skip the widget and label
					if(creationSpec.isMissingWidget && !WorkItemUtil.isDebugMode()) return;
					
					if(creationSpec.isMissingWidget) {
						creationArgs.widgetName = creationSpec.widgetName;
						creationArgs.isMissingWidget = creationSpec.isMissingWidget;
					}
					
					var widget = new widgetClass(creationArgs, valueNode);
					
					if (presentation && presentation.displaySpec) {
					
						var displaySpec = presentation.displaySpec;
						
						if (widget.getLabel && displaySpec.labelSpan) {
							dojox.data.dom.removeChildren(displaySpec.labelSpan);
							var text = document.createTextNode(widget.getLabel());
							displaySpec.labelSpan.appendChild(text);
						}
						
						if (displaySpec.hasDeferredLabel  && displaySpec.labelSpan) {
							if (displaySpec.labelSpan.innerHTML == "" && presentation.attributeId) { /* innerHTML OK */
								var text = document.createTextNode(presentation.attributeId + ": ");
								displaySpec.labelSpan.appendChild(text);
							}
						}
					}					
					if(sectionLayout) {
						sectionLayout.addChildWidget(widget);	
					}
					
					var i=0;
					var id = attributeId;
					while(this._childWidgets[id]) {
						id = attributeId + i++;
					}
					this._childWidgets[id] = widget;
			}
		},
		
		reset: function() {
		
		 },
		// return an object containing form name-value pairs
		getFormElements: function() {		// return an object containing form name-value pairs
			var formElementValues= {};
			var self = this;
			for(var widget in this._childWidgets) {
					if(this._childWidgets[widget].getFormElementValues) {
						this._childWidgets[widget].getFormElementValues(formElementValues);
					}
				}
			return formElementValues;
		},
		
		getSaveCommands: function(allCommands) {
			for(var widgetId in this._childWidgets) {
				var widget = this._childWidgets[widgetId];
				if(widget) {
					if (widget.getSaveCommands) {
						widget.getSaveCommands(allCommands);
				}
				}
			}
			return allCommands;
		},
		hasRetainedState: function() {
			return false;
		},
		clearRetainedState: function() {
			
		},
		markFullyLoaded: function() {

		},
		//
		// event-related methods
		//
		
		_handleDirtyingEvent: function(e) {
			this.parentController.conditionalMarkDirty(e);
		},
		markDirty: function() {
			this._isDirty = true;
		}		
	}
);

})();
