/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorLabel");

dojo.require("dojox.data.dom");
dojo.require("dijit.Tooltip");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");

(function() {
	
dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorLabel",
	[], {
	
	///////////////////////////////////////////////////////////////////////////////////
	// Called on creation
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
		this.errorElement= args.errorElement;
	},
	
	postCreate: function() {
		this._originalDisplay= this.errorElement.style.display;
		
		this._messageSpan= document.createElement("span");
		this.errorElement.appendChild(this._messageSpan);
		
		this._toolTip= new dijit.Tooltip({ label: "", connectId: this._messageSpan}, this.errorElement);
		this.clearError();
	},
	destroy: function() {
		if(this._toolTip && this._toolTip.destroy) this._toolTip.destroy();
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	showError: function(message, error) {
		dojox.data.dom.replaceChildren(this._messageSpan, document.createTextNode(message));
		this._toolTip.label= error.message ? error.message : this.messages.errorNoDetailsAvailable ;
		this.errorElement.style.display= this._originalDisplay;
	},
	
	clearError: function() {
		this.errorElement.style.display= "none";
	}
	
});

})();
