/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.util.internal.HTMLUtility");

/*
 * Imports 
 */
dojo.require("dojo.i18n"); 
dojo.require("net.jazz.ajax.toolbox.lang.internal.html");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var HTML = net.jazz.ajax.toolbox.lang.internal.html;

/*
 * Class 
 */
com.ibm.team.dashboard.web.util.internal.HTMLUtility = {

	isMessagesLoaded: false,

	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 */	
	_loadMessages: function() {
		if (this.isMessagesLoaded) {
			return;
		}
		this.messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
		this.isMessagesLoaded = true;
	},

	/*
 	 * Public Method
 	 * 
 	 * @param String html
 	 * @return boolean
 	 */	
	isSecureHTMLContent: function(html) {
		// Load externalized strings
		this._loadMessages();
		
		// Check for insecure content
		if (html.match(/<script/i)) {
			// Insecure content found
			alert(this.messages.msgHTMLErrorScriptTags);
			return false;
		} else if (html.match(/on[a-z]+[\s]*=/i)) {
			// Insecure content found
			alert(this.messages.msgHTMLErrorEventHandlers);
			return false;
		// delegate to backported common component
		} else if (HTML.hasScript(html)) {
			// Insecure content found
			alert(this.messages.msgHTMLErrorQualifiers);
			return false;
		}		

		// No insecure content found
		return true;
	},
	
	/*
	 * Returns a new string with all special HTML characters escaped.
	 * e.g. "hello <b>world</b>" -> "hello &lt;b&gt;world&lt;/b&gt;"
	 */
	/* string */ escapeHTML: function(/* string */ text) {
		// delegate to backported common component
		return HTML.escape(text);
	},
	
	/*
	 * Sanitizes a fragment of HTML markup by removing all scripting, event
	 * handlers, and "javascript:" link hrefs.
	 */
	/* string */ sanitizeHTML: function(/* string */ html) {
		// delegate to backported common component
		return HTML.removeScript(html);
	}
};


})();

